#include <avr/io.h>
#include "typedefs.h"

/*****************************************************
 *    
 * :
 * address - 16-   ,
 *  ATmega16A - 0...1FF (512 )
 *  :
 *     
 *****************************************************/
UINT8 EERead(UINT16 address)
{
   while(EECR & (1<<EEWE));

   EEAR = address;
   /* Start eeprom read by writing EERE */
   EECR |= (1<<EERE);
   /* Return data from data register */
   return EEDR;
}
/*****************************************************
 *    
 * :
 * address -   ,
 *  ATmega16A - 0...1FF (512 )
 * byte -   
 *  : 
 *****************************************************/
void EEWrite(UINT16 address, UINT8 byte)
{
   while(EECR & (1<<EEWE));

   EEAR = address;
   EEDR = byte;

   /* Write logical one to EEMWE */
   EECR |= (1<<EEMWE);
   /* Start eeprom write by setting EEWE */
   EECR |= (1<<EEWE);
}
