#define  _DEBUG  0  // 1 - 
#define  WINSTAR 1  // 1 -    WINSTAR, 0 -   

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <string.h>
#include "typedefs.h"

/*   CRC16 */
#define CRC_BIT_LENGTH  0x10
#define CRC_POLYN       0x11021
#define CRC_HIGHBIT     0x10000
#define CRC_MASK        0x0FFFF

/*       (   IC-910) */
void CLR_ALL_LEDS(void);
void inline SET_LED_144MHZ(void);
void inline CLR_LED_144MHZ(void);
void inline SET_LED_430MHZ(void);
void inline CLR_LED_430MHZ(void);
void inline SET_LED_1200MHZ(void);
void inline CLR_LED_1200MHZ(void);
void inline SET_LEDFindConnect(void);
void inline CLR_LEDFindConnect(void);
void TOGGLE_LEDFindConnect(void);
UINT32 BCD2Int32(UINT8* p_mass);

/*       */
void   IOinit(void);
void   SET_E(void);
void   CLR_E(void);
void   SET_A0(void);
void   CLR_A0(void);
void   LCDinit(void);
void   LCD_write_cmd(UINT8);
void   LCD_write_data(UINT8);
void   LCD_write(UINT8 value, UINT8 cd);
void   Wait_uS(UINT16 pause);
void   Wait_mS(UINT16 pause);
void   lcd_print_dec(UINT16 arg);
void   lcd_print_time(UINT8 ciffer);
void   lcd_print_str(char *text);
void   lcd_print_hex_byte(UINT8 byte);
void   cls(void);
void   hex_print_16(INT16 value);
void   Locate(UINT8 line, UINT8 pos);

/*       */
#define lcd_print_char(arg) LCD_write_data(arg)

/*      UART */
void   UARTinit(uint32_t Baud);
UINT8  UARTReceive(void);
void   UARTTransmit(UINT8 Data);

/*      EEPROM */
UINT8  EERead(UINT16 address);
void   EEWrite(UINT16 address, UINT8 byte);
UINT8  EEGetNumberOfRadios(void);
void   EESetNumberOfRadios(UINT8 num);
UINT16 CalcCRC16(void);
UINT16 EEGetCS(void);
bool   EECheckCS(void);
void   EECalcAndWriteCS(void);
bool   EEGetParam(UINT8 num, UINT8* ar, UINT16* br);
void   EESetParam(UINT8 num, UINT8 ar, UINT16 br);
void   EEADDRadio(UINT8 ar, UINT16 br);

/*     */
UINT8  read_line(void);
UINT8  STOPsearch(UINT8 start_index);
void   FreqPrint(void);
void   FreqPrintChar(UINT8 byte, UINT8 *index);
void   ModePrint(void);
void   print_reply();
void   SMeterPrint(void);
void   BCD2cif(UINT16* smeter);
bool   radio_search(UINT16 br);
void   RAinit(UINT8 radio_address);
bool   radio_check_connection(UINT8 ra);
bool   radio_check_exist(UINT8 ra);
void   get_data(UINT8* p_cmd, UINT8* p_rply_ok, UINT8* p_rply_ok2, UINT8* p_rply,
              UINT8 l_cmd, UINT8 l_rply_ok, UINT8 l_rply_ok2, UINT8 l_rply, void (*call_func)(void));
void   pause(void);

typedef struct
{
    UINT16 mode_data;
    char*  mode_str;
} MODE;
